## kido 0.1.0%2Bdfsg

=== kido/CMakeLists.txt ===
# Enable multi-threaded compilation.
# We do this here and not in the root folder since the example apps
# do not have enough source files to benefit from this.
if(MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
endif()

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")

# Add subdirectories
add_subdirectory(common)
add_subdirectory(math)
add_subdirectory(integration)
add_subdirectory(collision)
add_subdirectory(lcpsolver)
add_subdirectory(constraint)
add_subdirectory(optimizer)
add_subdirectory(dynamics)
add_subdirectory(renderer)
add_subdirectory(simulation)

if(FLANN_FOUND)
  add_subdirectory(planning)
endif()

if(GLUT_FOUND)
  add_subdirectory(gui)
endif()

if(TINYXML_FOUND AND TINYXML2_FOUND AND urdfdom_FOUND)
  add_subdirectory(utils)
endif()

# Set header and source files
set(kido_hdrs
  kido.hpp
  ${kido_common_hdrs}
  ${kido_math_hdrs}
  ${kido_integration_hdrs}
  ${kido_lcpsolver_hdrs}
  ${kido_dynamics_hdrs}
  ${kido_optimizer_hdrs}
  ${kido_collision_hdrs}
  ${kido_constraint_hdrs}
  ${kido_renderer_hdrs}
  ${kido_simulation_hdrs}
)
set(kido_srcs
  ${kido_common_srcs}
  ${kido_math_srcs}
  ${kido_integration_srcs}
  ${kido_lcpsolver_srcs}
  ${kido_dynamics_srcs}
  ${kido_optimizer_srcs}
  ${kido_collision_srcs}
  ${kido_constraint_srcs}
  ${kido_renderer_srcs}
  ${kido_simulation_srcs}
)

# Library: kido
kido_add_library(kido ${kido_hdrs} ${kido_srcs})
target_link_libraries(kido ${KIDO_DEPENDENCIES})

if(MSVC)
  set_target_properties(
    ${target} PROPERTIES
    STATIC_LIBRARY_FLAGS_RELEASE "/LTCG"
  )
endif()

install(FILES kido.hpp DESTINATION include/kido/ COMPONENT headers)
install(TARGETS kido EXPORT KIDOTargets DESTINATION lib)

=== apps/addDeleteSkels/CMakeLists.txt ===
###############################################
# apps/addDeleteSkels
file(GLOB addDeleteSkels_srcs "*.cpp")
file(GLOB addDeleteSkels_hdrs "*.hpp")
add_executable(addDeleteSkels ${addDeleteSkels_srcs} ${addDeleteSkels_hdrs})
target_link_libraries(addDeleteSkels kido kido-gui)
set_target_properties(addDeleteSkels PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== apps/atlasSimbicon/CMakeLists.txt ===
###############################################
# apps/atlasSimbicon
file(GLOB atlasSimbicon_srcs "*.cpp")
file(GLOB atlasSimbicon_hdrs "*.hpp")
add_executable(atlasSimbicon ${atlasSimbicon_srcs} ${atlasSimbicon_hdrs})
target_link_libraries(atlasSimbicon kido kido-gui)
set_target_properties(atlasSimbicon PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== apps/speedTest/CMakeLists.txt ===
###############################################################
# This file can be used as-is in the directory of any app,    #
# however you might need to specify your own dependencies in  #
# target_link_libraries if your app depends on more than kido #
###############################################################
get_filename_component(app_name ${CMAKE_CURRENT_LIST_DIR} NAME)
file(GLOB ${app_name}_srcs "*.cpp" "*.hpp" "*.hpp")
add_executable(${app_name} ${${app_name}_srcs})
target_link_libraries(${app_name} kido kido-gui)
set_target_properties(${app_name} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== kido/collision/fcl_mesh/CMakeLists.txt ===
# Search all header and source files
file(GLOB srcs "*.cpp")
file(GLOB hdrs "*.hpp")

set(kido_collision_hdrs ${kido_collision_hdrs} ${hdrs} PARENT_SCOPE)
set(kido_collision_srcs ${kido_collision_srcs} ${srcs} PARENT_SCOPE)

# Library
#kido_add_library(kido_collision_fcl_mesh ${srcs} ${hdrs})
#target_link_libraries(kido_collision_fcl_mesh ${KIDO_CORE_DEPENDENCIES})

# Generate header for this namespace
kido_get_filename_components(header_names "collision_fcl_mesh headers" ${hdrs})
kido_generate_include_header_list(
  collision_fcl_mesh_headers
  "kido/collision/fcl_mesh/"
  "collision_fcl_mesh headers"
  ${header_names}
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/fcl_mesh.hpp.in
  ${CMAKE_CURRENT_BINARY_DIR}/fcl_mesh.hpp
)

# Install
install(
  FILES ${hdrs} ${CMAKE_CURRENT_BINARY_DIR}/fcl_mesh.hpp
  DESTINATION include/kido/collision/fcl_mesh
  COMPONENT headers
)
#install(TARGETS kido_collision_fcl_mesh EXPORT KIDOCoreTargets DESTINATION lib)
#install(TARGETS kido_collision_fcl_mesh EXPORT KIDOTargets DESTINATION lib)

=== debian/changelog ===
kido (0.1.0+dfsg-2build9) bionic; urgency=medium

  * No-change rebuild for tinyxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 30 Jan 2018 06:35:31 +0000

kido (0.1.0+dfsg-2build8) bionic; urgency=medium

  * No-change rebuild against latest assimp

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sat, 25 Nov 2017 18:58:48 -0500

kido (0.1.0+dfsg-2build7) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:17:10 +0000

kido (0.1.0+dfsg-2build6) artful; urgency=medium

  * No-change rebuild against libbullet2.86

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 26 Jul 2017 20:08:08 +0000

kido (0.1.0+dfsg-2build5) artful; urgency=medium

  * No-change rebuild against latest tinyxml2

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 14 Jul 2017 14:18:25 -0400

kido (0.1.0+dfsg-2build4) zesty; urgency=medium

  * Rebuild against new 2.83.7.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 09 Nov 2016 08:47:38 +0100

kido (0.1.0+dfsg-2build3) zesty; urgency=medium

  * Rebuild against new bullet 2.83.7.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 05 Nov 2016 10:08:34 +0100

kido (0.1.0+dfsg-2build2) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:25:08 +0000

kido (0.1.0+dfsg-2build1) yakkety; urgency=medium

  * Rebuild against new liburdfdom-dev.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 15 Sep 2016 13:17:07 +0200

kido (0.1.0+dfsg-2) unstable; urgency=medium

  * Use std::shared instead of boost::shared
    (Closes: #835734)
  * Patch to remove msse2 compiler flag
    (Closes: #833817)
  * Add a patch to fix link of unitests
    (Closes: #835930)
  * Fix tinyxml new constant

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 30 Aug 2016 22:52:53 +0000

kido (0.1.0+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #812126)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 21 Jul 2016 14:33:19 +0000

## kido 0.1.0+dfsg

=== CMakeLists.txt ===
#===============================================================================
# CMake settings
#===============================================================================
if(MSVC)
  cmake_minimum_required(VERSION 3.1.3)
else()
  cmake_minimum_required(VERSION 2.8.6)
endif()

# Use MACOSX_RPATH by default on OS X. This was added in CMake 2.8.12 and
# became default in CMake 3.0. Explicitly setting this policy is necessary to
# suppress a warning in CMake 3.0 and above.
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW)
endif()

# Simplify variable reference and escape sequence evaluation. This was added in
# CMake 3.1. Explicitly setting this policy is necessary to suppress a warning
# in CMake 3.1 and above.
if(POLICY CMP0053)
  cmake_policy(SET CMP0053 NEW)
endif()

# Disables a warning about a change in Cygwin Cmake
set(CMAKE_LEGACY_CYGWIN_WIN32 0)
set(CMAKE_CXX_WARNING_LEVEL 4)

set(CMAKE_DEBUG_POSTFIX "d")
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(${CMAKE_MODULE_PATH}/KIDOMacros.cmake)

# System install paths on Windows
if(WIN32)
  set(CMAKE_INSTALL_PREFIX "C:/Golems" CACHE PATH "Install prefix" FORCE)
endif()

#===============================================================================
# Project settings
#===============================================================================
#
# If you change the version, please update the <version> tag in package.xml.

project(kido)

set(KIDO_MAJOR_VERSION "0")
set(KIDO_MINOR_VERSION "1")
set(KIDO_PATCH_VERSION "0")
set(KIDO_VERSION "${KIDO_MAJOR_VERSION}.${KIDO_MINOR_VERSION}.${KIDO_PATCH_VERSION}")
set(KIDO_PKG_DESC "Kinematics, Dynamics and Optimization Library for Animation and Robotics")
set(KIDO_PKG_EXTERNAL_DEPS "flann, ccd, fcl")

#===============================================================================
# Print intro
#===============================================================================
message(STATUS "")
message(STATUS "============================================")
message(STATUS "                KIDO ${KIDO_VERSION}")
message(STATUS "============================================")

#===============================================================================
# Build options
#===============================================================================
option(ENABLE_OPENMP "Build with OpenMP parallaization enabled" ON)
if(MSVC)
  set(KIDO_RUNTIME_LIBRARY "/MD" CACHE STRING "BaseName chosen by the user at CMake configure time")
  set_property(CACHE KIDO_RUNTIME_LIBRARY PROPERTY STRINGS /MD /MT)
  option(KIDO_MSVC_DEFAULT_OPTIONS "Build KIDO with default Visual Studio options" OFF)
else()
  option(BUILD_SHARED_LIBS "Build shared libraries" ON)
endif()
option(KIDO_BUILD_OSGKIDO "Build osgKido library" ON) # TODO(JS): Rename the option name to more relevant name to osg GUI and add more options for other extensions (#590).
option(KIDO_BUILD_EXAMPLES "Build examples" ON)
option(KIDO_BUILD_TUTORIALS "Build tutorials" ON)
option(KIDO_BUILD_UNITTESTS "Build unit tests" ON)

#===============================================================================
# Build type settings
#===============================================================================
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: Debug | Release | RelWithDebInfo | MinSizeRel" FORCE)
endif()
string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPPERCASE)

set(BUILD_TYPE_DEBUG FALSE)
set(BUILD_TYPE_RELEASE FALSE)
set(BUILD_TYPE_RELWITHDEBINFO FALSE)
set(BUILD_TYPE_MINSIZEREL FALSE)

if("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "DEBUG")
  set(BUILD_TYPE_DEBUG TRUE)
elseif("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELEASE")
  set(BUILD_TYPE_RELEASE TRUE)
elseif("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELWITHDEBINFO")
  set(BUILD_TYPE_RELWITHDEBINFO TRUE)
elseif("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "MINSIZEREL")
  set(BUILD_TYPE_MINSIZEREL TRUE)
else()
  build_error("CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} unknown. Valid options are: Debug | Release | RelWithDebInfo | MinSizeRel")
endif()

#===============================================================================
# Find dependencies
#===============================================================================
#
# If you add a dependency, please add the corresponding rosdep key as a
# dependency in package.xml.

#------------------------
# Mandatory dependencies
#------------------------
message(STATUS "")
message(STATUS "[ Mandatory dependencies ]")

# Eigen
find_package(EIGEN3 3.0.5 QUIET)
if(EIGEN3_FOUND)
  message(STATUS "Looking for EIGEN3 - ${EIGEN3_VERSION} found")
else()
  if(PC_EIGEN3_VERSION)
    message(SEND_ERROR "Looking for EIGEN3 - ${EIGEN3_VERSION} found, ${PROJECT_NAME} requires 3.0.5 or greater.")
  else()
    message(SEND_ERROR "Looking for EIGEN3 - NOT found, please install libeigen3-dev")
  endif()
endif()

# CCD
find_package(CCD 1.4.0 QUIET)
if(CCD_FOUND)
  message(STATUS "Looking for CCD - ${CCD_VERSION} found")
else()
  if(CCD_VERSION)
    message(SEND_ERROR "Looking for CCD - ${CCD_VERSION} found, ${PROJECT_NAME} requires 1.4.0 or greater.")
  else()
    message(SEND_ERROR "Looking for CCD - NOT found, please install libccd-dev")
  endif()
endif()

# FCL
# TODO: We need to increate the minimum required fcl version to 0.4.0 for KIDO
# 7.0 once fcl 0.4.0 is released.
find_package(FCL 0.2.9 QUIET)
if(FCL_FOUND)
  message(STATUS "Looking for FCL - ${FCL_VERSION} found")
else()
  if(FCL_VERSION)
    message(SEND_ERROR "Looking for FCL - ${FCL_VERSION} found, ${PROJECT_NAME} requires 0.2.9 or greater.")
  else()
    message(SEND_ERROR "Looking for FCL - NOT found, please install libfcl-dev")
  endif()
endif()

# ASSIMP
find_package(ASSIMP 3.0.0 QUIET)
if(ASSIMP_FOUND)
  message(STATUS "Looking for ASSIMP - ${ASSIMP_VERSION} found")

  # Check for missing symbols in ASSIMP (see #451)
  include(CheckCXXSourceCompiles)
  set(CMAKE_REQUIRED_INCLUDES ${ASSIMP_INCLUDE_DIRS})
  set(CMAKE_REQUIRED_LIBRARIES ${ASSIMP_LIBRARIES})
  set(CMAKE_REQUIRED_QUIET TRUE)

  check_cxx_source_compiles(
  "
  #include <assimp/scene.h>
  int main()
  {
    aiScene* scene = new aiScene;
    delete scene;
    return 1;
  }
  "
  ASSIMP_AISCENE_CTOR_DTOR_DEFINED)

  if(NOT ASSIMP_AISCENE_CTOR_DTOR_DEFINED)
    message(WARNING "The installed version of ASSIMP (${ASSIMP_VERSION}) is "
                    "missing symbols for the constructor and/or destructor of "
                    "aiScene. KIDO will use its own implementations of these "
                    "functions. We recommend using a version of ASSIMP that "
                    "does not have this issue, once one becomes available.")
  endif(NOT ASSIMP_AISCENE_CTOR_DTOR_DEFINED)

  check_cxx_source_compiles(
  "
  #include <assimp/material.h>
  int main()
  {
    aiMaterial* material = new aiMaterial;
    delete material;
    return 1;
  }
  "
  ASSIMP_AIMATERIAL_CTOR_DTOR_DEFINED)

  if(NOT ASSIMP_AIMATERIAL_CTOR_DTOR_DEFINED)
    message(WARNING "The installed version of ASSIMP (${ASSIMP_VERSION}) is "
                    "missing symbols for the constructor and/or destructor of "
                    "aiMaterial. KIDO will use its own implementations of "
                    "these functions. We recommend using a version of ASSIMP "
                    "that does not have this issue, once one becomes available.")
  endif(NOT ASSIMP_AIMATERIAL_CTOR_DTOR_DEFINED)

  unset(CMAKE_REQUIRED_INCLUDES)
  unset(CMAKE_REQUIRED_LIBRARIES)
  unset(CMAKE_REQUIRED_QUIET)

else()
  if(ASSIMP_VERSION)
    message(SEND_ERROR "Looking for ASSIMP - ${ASSIMP_VERSION} found, ${PROJECT_NAME} requires 3.0.0 or greater.")
  else()
    message(SEND_ERROR "Looking for ASSIMP - NOT found, please install libassimp-dev")
  endif()
endif()

# OpenGL
find_package(OpenGL QUIET)
if(OPENGL_FOUND)
  message(STATUS "Looking for OpenGL - found")
else()
  message(SEND_ERROR "Looking for OpenGL - NOT found, please install OpenGL")
endif()

# Boost
set(KIDO_MIN_BOOST_VERSION 1.46.0 CACHE INTERNAL "Boost min version requirement" FORCE)
if(MSVC OR MSVC90 OR MSVC10)
  add_definitions(-DBOOST_ALL_NO_LIB)
endif()
add_definitions(-DBOOST_TEST_DYN_LINK)
set(Boost_USE_MULTITHREADED ON)
set(Boost_USE_STATIC_RUNTIME OFF)
find_package(Boost ${KIDO_MIN_BOOST_VERSION} COMPONENTS regex system QUIET)
if(Boost_FOUND)
  message(STATUS "Looking for Boost - ${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_SUBMINOR_VERSION} found")
else()
  message(SEND_ERROR "Please install system boost version ${KIDO_MIN_BOOST_VERSION} or higher.")
endif()

#-----------------------
# Optional dependencies
#-----------------------
message(STATUS "")
message(STATUS "[ Optional dependencies ]")

# GLUT
if(WIN32 AND NOT CYGWIN)
  set(GLUT_INCLUDE_DIR "@CMAKE_INSTALL_PREFIX@/include")
  set(GLUT_LIBRARIES glut32)
else()
  find_package(GLUT QUIET)
  if(GLUT_FOUND)
    message(STATUS "Looking for GLUT - found")
    set(GLUT_LIBRARIES ${GLUT_glut_LIBRARY})
  else()
    message(STATUS "Looking for GLUT - NOT found")
    message(STATUS "To enable component kido-gui, please install freeglut3-dev")
  endif()
endif()

# OpenSceneGraph
find_package(OpenSceneGraph 3.0 QUIET
  COMPONENTS osg osgViewer osgManipulator osgGA osgDB)
if(OPENSCENEGRAPH_FOUND)
  message(STATUS "Looking for OpenSceneGraph -- ${OPENSCENEGRAPH_VERSION} found")
  set(HAVE_OPENSCENEGRAPH TRUE)
else(OPENSCENEGRAPH_FOUND)
  # kido-gui-osg requires both OSG and OpenThreads. This section attempts to
  # identify which of those are missing from the building machine and offer
  # advice to the user for getting osgKido to build.
  find_package(OpenThreads QUIET)
  if(OPENTHREADS_FOUND)
    set(warning_msg "Could NOT find OpenSceneGraph")
  else(OPENTHREADS_FOUND)
    if(OSG_LIBRARY)
      set(warning_msg "Could NOT find OpenThreads")
    else(OSG_LIBRARY)
      set(warning_msg "Could NOT find OpenSceneGraph nor OpenThreads")
    endif(OSG_LIBRARY)
  endif(OPENTHREADS_FOUND)
  message(WARNING "${warning_msg} -- we will skip kido-gui-osg\n"
          "If you believe you do have both OSG and OpenThreads installed, try setting OSG_DIR")
  set(HAVE_OPENSCENEGRAPH FALSE)
endif(OPENSCENEGRAPH_FOUND)

# FLANN
find_package(FLANN 1.8.4 QUIET)
if(FLANN_FOUND)
  message(STATUS "Looking for FLANN - ${FLANN_VERSION} found")
else()
  if(FLANN_VERSION)
    message(STATUS "Looking for FLANN - ${FLANN_VERSION} (< 1.8.4) found")
    message(STATUS "To enable component kido-planning, please install libflann-dev 1.8.4 or greater")
  else()
    message(STATUS "Looking for FLANN - NOT found")
    message(STATUS "To enable component kido-planning, please install libflann-dev")
  endif()
endif()

# TINYXML
find_package(TINYXML 2.6.2 QUIET)
if(TINYXML_FOUND)
  message(STATUS "Looking for TINYXML - ${TINYXML_VERSION} found")
else()
  if(TINYXML_VERSION)
    message(STATUS "Looking for TINYXML - ${TINYXML_VERSION} (< 2.6.2) found")
    message(STATUS "To enable component kido-utils, please install libtinyxml-dev 2.6.2 or greater")
  else()
    message(STATUS "Looking for TINYXML - NOT found")
    message(STATUS "To enable component kido-utils, please install libtinyxml-dev")
  endif()
endif()

# TINYXML2
find_package(TINYXML2 QUIET)
if(TINYXML2_FOUND)
  message(STATUS "Looking for TINYXML2 - ${TINYXML2_VERSION} found")
else()
  if(TINYXML2_VERSION)
    message(STATUS "Looking for TINYXML2 - ${TINYXML2_VERSION} (< 1.0.1) found")
    message(STATUS "To enable component kido-utils, please install libtinyxml2-dev 1.0.1 or greater")
  else()
    message(STATUS "Looking for TINYXML2 - NOT found")
    message(STATUS "To enable component kido-utils, please install libtinyxml2-dev")
  endif()
endif()

# urdfdom
find_package(urdfdom QUIET)
if(urdfdom_FOUND)
  message(STATUS "Looking for urdfdom - found")
else()
  message(STATUS "Looking for urdfdom - NOT found, please install liburdfdom-dev")
  message(STATUS "To enable component kido-utils, please install liburdfdom-dev")
endif()
if(MSVC)

=== apps/CMakeLists.txt ===
# A list of applications
set_property(DIRECTORY PROPERTY FOLDER Apps)

message(STATUS "")
message(STATUS "[ Applications ]")

# Automatically identify all directories in the apps folder
file(GLOB children RELATIVE ${CMAKE_CURRENT_LIST_DIR} "*")
set(directories "")
foreach(child ${children})
  if(IS_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}/${child}")
    if(EXISTS "${CMAKE_CURRENT_LIST_DIR}/${child}/CMakeLists.txt")
      message(STATUS "Adding application: " ${child})
      list(APPEND directories ${child})
    endif(EXISTS "${CMAKE_CURRENT_LIST_DIR}/${child}/CMakeLists.txt")
  endif(IS_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}/${child}")
endforeach(child)

# List of all the subdirectories to include
foreach(APPDIR ${directories})
  add_subdirectory(${APPDIR})
  if(WIN32)
    if(TARGET ${APPTARGET})
      set_target_properties(${APPTARGET} PROPERTIES FOLDER Apps
          #EXCLUDE_FROM_DEFAULT_BUILD ON
          )
      set_target_properties(${APPTARGET} PROPERTIES STATIC_LIBRARY_FLAGS_RELEASE "/LTCG")
    endif(TARGET ${APPTARGET})
  endif(WIN32)
endforeach(APPDIR)

=== tutorials/CMakeLists.txt ===
file(GLOB tutorials_src "*.cpp")
list(SORT tutorials_src)

message(STATUS "")
message(STATUS "[ Tutorials ]")

foreach(tutorial ${tutorials_src})
  get_filename_component(tutorial_base ${tutorial} NAME_WE)
  message(STATUS "Adding tutorial: ${tutorial_base}")
  add_executable(${tutorial_base} ${tutorial})
  target_link_libraries(${tutorial_base} kido kido-gui)
endforeach(tutorial)

=== unittests/CMakeLists.txt ===
#
# Copyright (c) 2013-2015, Georgia Tech Research Corporation
# All rights reserved.
#
# Author(s): Can Erdogan <cerdogan3@gatech.edu>,
#            Jeongseok Lee <jslee02@gmail.com>
#
# Georgia Tech Graphics Lab and Humanoid Robotics Lab
#
# Directed by Prof. C. Karen Liu and Prof. Mike Stilman
# <karenliu@cc.gatech.edu> <mstilman@cc.gatech.edu>
#
# This file is provided under the following "BSD-style" License:
#   Redistribution and use in source and binary forms, with or
#   without modification, are permitted provided that the following
#   conditions are met:
#   * Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above
#     copyright notice, this list of conditions and the following
#     disclaimer in the documentation and/or other materials provided
#     with the distribution.
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#   CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#   INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#   DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
#   AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
#   ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
#   POSSIBILITY OF SUCH DAMAGE.
#

# Create a macro to check if a list contains a value
macro(list_contains var value)
  set(${var})
  foreach (value2 ${ARGN})
    if(${value} STREQUAL ${value2})
      set(${var} true)
    endif (${value} STREQUAL ${value2})
  endforeach (value2)
endmacro(list_contains)

# Include and link to gtest
include_directories(${CMAKE_SOURCE_DIR}/unittests/gtest/include)
include_directories(${CMAKE_SOURCE_DIR}/unittests/gtest)
add_library(gtest STATIC gtest/src/gtest-all.cc)
add_library(gtest_main STATIC gtest/src/gtest_main.cc)
target_link_libraries(gtest_main gtest)
if(NOT WIN32)
  target_link_libraries(gtest pthread)
endif()
set_target_properties(gtest PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

# Compile each test file
message(STATUS "")
message(STATUS "[ Unit tests ]")
file(GLOB tests "test*.cpp")
foreach(test ${tests})

  # Get the name (i.e. bla.cpp => bla)
  get_filename_component(base ${test} NAME_WE)
  link_directories(${KIDOExt_LIBRARY_DIRS})
  add_executable(${base} ${test})
  if(MSVC)
    target_link_libraries(${base} kido kido-utils optimized gtest debug gtestd)
  else()
    target_link_libraries(${base} kido kido-utils gtest)
  endif()

  set_target_properties(${base} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/tests")

  # Add the executable if not to be ignored
  list_contains(contains ${base} ${dontTest})
  if(NOT contains)
    add_test(${base} ${CMAKE_BINARY_DIR}/bin/tests/${base})
    message(STATUS "Adding test: " ${base})
  endif(NOT contains)

endforeach(test)

if(HAVE_IPOPT)
  target_link_libraries(testOptimizer kido-optimizer-ipopt)
endif(HAVE_IPOPT)

if(HAVE_NLOPT)
  target_link_libraries(testOptimizer kido-optimizer-nlopt)
endif(HAVE_NLOPT)

if(HAVE_SNOPT)
  target_link_libraries(testOptimizer kido-optimizer-snopt)
endif(HAVE_SNOPT)

=== apps/bipedStand/CMakeLists.txt ===
###############################################
# apps/bipedStand
file(GLOB bipedStand_srcs "*.cpp")
file(GLOB bipedStand_hdrs "*.hpp")
add_executable(bipedStand ${bipedStand_srcs} ${bipedStand_hdrs})
target_link_libraries(bipedStand kido kido-gui)
set_target_properties(bipedStand PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== apps/hardcodedDesign/CMakeLists.txt ===
###############################################
# apps/hardcodedDesign

file(GLOB hardcodedDesign_srcs "*.cpp")
file(GLOB hardcodedDesign_hdrs "*.hpp")
add_executable(hardcodedDesign ${hardcodedDesign_srcs} ${hardcodedDesign_hdrs})
target_link_libraries(hardcodedDesign kido kido-gui)
set_target_properties(hardcodedDesign PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== apps/hybridDynamics/CMakeLists.txt ===
###############################################
# apps/hybridDynamics
file(GLOB hybridDynamics_srcs "*.cpp")
file(GLOB hybridDynamics_hdrs "*.hpp")
add_executable(hybridDynamics ${hybridDynamics_srcs} ${hybridDynamics_hdrs})
target_link_libraries(hybridDynamics kido kido-gui)
set_target_properties(hybridDynamics PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== apps/jointConstraints/CMakeLists.txt ===
###############################################
# apps/jointConstraints
file(GLOB jointConstraints_srcs "*.cpp")
file(GLOB jointConstraints_hdrs "*.hpp")
add_executable(jointConstraints ${jointConstraints_srcs} ${jointConstraints_hdrs})
target_link_libraries(jointConstraints kido kido-gui)
set_target_properties(jointConstraints PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== apps/mixedChain/CMakeLists.txt ===
###############################################
# apps/mixedChain
set(APP_NAME mixedChain)
file(GLOB ${APP_NAME}_srcs "*.cpp")
file(GLOB ${APP_NAME}_hdrs "*.hpp")
add_executable(${APP_NAME} ${${APP_NAME}_srcs} ${${APP_NAME}_hdrs})
target_link_libraries(${APP_NAME} kido kido-gui)
set_target_properties(${APP_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== apps/operationalSpaceControl/CMakeLists.txt ===
###############################################
# apps/operationalSpaceControl
file(GLOB operationalSpaceControl_srcs "*.cpp")
file(GLOB operationalSpaceControl_hdrs "*.hpp")
add_executable(operationalSpaceControl ${operationalSpaceControl_srcs} ${operationalSpaceControl_hdrs})
target_link_libraries(operationalSpaceControl kido kido-gui)
set_target_properties(operationalSpaceControl PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== apps/rigidChain/CMakeLists.txt ===
###############################################
# apps/rigidChain
file(GLOB rigidChain_srcs "*.cpp")
file(GLOB rigidChain_hdrs "*.hpp")
add_executable(rigidChain ${rigidChain_srcs} ${rigidChain_hdrs})
target_link_libraries(rigidChain kido kido-gui)
set_target_properties(rigidChain PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== apps/rigidCubes/CMakeLists.txt ===
###############################################
# apps/rigidCubes
file(GLOB rigidCubes_srcs "*.cpp")
file(GLOB rigidCubes_hdrs "*.hpp")
add_executable(rigidCubes ${rigidCubes_srcs} ${rigidCubes_hdrs})
target_link_libraries(rigidCubes kido kido-gui)
set_target_properties(rigidCubes PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

=== debian/changelog ===
kido (0.1.0+dfsg-6) unstable; urgency=medium

  * Team upload.
  [ Jelmer Vernooĳ ]
  * Remove unnecessary 'Testsuite: autopkgtest' header.

  [ Jochen Sprickerhof ]
  * Add patch to fix Flann inclusion

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 14 Oct 2018 23:59:26 +0200

kido (0.1.0+dfsg-5) unstable; urgency=medium

  * Team upload
  * Change back the include to add <kido> namespace,
    since the autogenerated pkgconfig file is not exporting it

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 11 Aug 2018 08:00:50 +0200

kido (0.1.0+dfsg-4) unstable; urgency=medium

  * Team upload
  * Fix testsuite
  * Install also pkgconfig file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 10 Aug 2018 19:53:18 +0200

kido (0.1.0+dfsg-3) unstable; urgency=medium

  * Team upload
  * Move VCS fields after salsa.d.o move
  * Fix a nlopt-related FTBFS, headers moved in cxx-dev (Closes: #905682)
    thanks <hyperair> for the patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 10 Aug 2018 10:09:28 +0200

=== debian/control ===
Source: kido
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9.20151219),
               cmake,
               libeigen3-dev,
               libfcl-dev (>= 0.2.7),
               libbullet-dev,
               libassimp-dev (>= 3),
               libnlopt-cxx-dev,
               coinor-libipopt-dev,
               freeglut3-dev,
               libxi-dev,
               libxmu-dev,
               libflann-dev (>= 1.8),
               libtinyxml-dev,
               libtinyxml2-dev,
               liburdfdom-dev,
               libboost-dev,
               libboost-system-dev,
               libboost-regex-dev,
               libopenthreads-dev,
               libopenscenegraph-dev
Standards-Version: 3.9.8
Vcs-Git: https://salsa.debian.org/science-team/kido.git
Vcs-Browser: https://salsa.debian.org/science-team/kido
Homepage: http://dartsim.github.io/

Package: libkido-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         libkido0.1 (= ${binary:Version}),
         libeigen3-dev,
         libassimp-dev (>= 3),
         libfcl-dev,
         libbullet-dev,
         libboost-all-dev
Description: Kinematics Dynamics and Optimization Library - development files
 KIDO is a collaborative, cross-platform, open source library created by the
 Georgia Tech Graphics Lab and Humanoid Robotics Lab. The library provides data
 structures and algorithms for kinematic and dynamic applications in robotics
 and computer animation.
 KIDO is distinguished by it's accuracy and stability due to its use of
 generalized coordinates to represent articulated rigid body systems and
 computation of Lagrange's equations derived from D.Alembert's principle to
 describe the dynamics of motion.
 For developers, in contrast to many popular physics engines which view the
 simulator as a black box, KIDO gives full access to internal kinematic and
 dynamic quantities, such as the mass matrix, Coriolis and centrifugal forces,
 transformation matrices and their derivatives. KIDO also provides efficient
 computation of Jacobian matrices for arbitrary body points and coordinate
 frames. Contact and collision are handled using an implicit time-stepping,
 velocity-based LCP (linear-complementarity problem) to guarantee
 non-penetration, directional friction, and approximated Coulomb friction cone
 conditions. For collision detection, KIDO uses FCL developed by Willow Garage
 and the UNC Gamma Lab.
 KIDO has applications in robotics and computer animation because it features a
 multibody dynamic simulator and tools for control and motion planning.
 Multibody dynamic simulation in KIDO is an extension of RTQL8, an open source
 software created by the Georgia Tech Graphics Lab.
 This package contains main headers and other tools for development.

Package: libkido0.1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Kinematics Dynamics and Optimization Library - main library
 KIDO is a collaborative, cross-platform, open source library created by the
 Georgia Tech Graphics Lab and Humanoid Robotics Lab. The library provides data
 structures and algorithms for kinematic and dynamic applications in robotics
 and computer animation.
 KIDO is distinguished by it's accuracy and stability due to its use of
 generalized coordinates to represent articulated rigid body systems and
 computation of Lagrange's equations derived from D.Alembert's principle to
 describe the dynamics of motion.
 For developers, in contrast to many popular physics engines which view the
 simulator as a black box, KIDO gives full access to internal kinematic and
 dynamic quantities, such as the mass matrix, Coriolis and centrifugal forces,
 transformation matrices and their derivatives. KIDO also provides efficient
 computation of Jacobian matrices for arbitrary body points and coordinate
 frames. Contact and collision are handled using an implicit time-stepping,
 velocity-based LCP (linear-complementarity problem) to guarantee
 non-penetration, directional friction, and approximated Coulomb friction cone
 conditions. For collision detection, KIDO uses FCL developed by Willow Garage
 and the UNC Gamma Lab.
 KIDO has applications in robotics and computer animation because it features a
 multibody dynamic simulator and tools for control and motion planning.
 Multibody dynamic simulation in KIDO is an extension of RTQL8, an open source
 software created by the Georgia Tech Graphics Lab.
 This package contains the main library of KIDO.

Package: libkido-planning-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         libkido-dev,
         libkido-planning0.1 (= ${binary:Version}),
         libflann-dev
Description: Kinematics Dynamics and Optimization Library - planning dev files
 KIDO is a collaborative, cross-platform, open source library created by the
 Georgia Tech Graphics Lab and Humanoid Robotics Lab. The library provides data
 structures and algorithms for kinematic and dynamic applications in robotics
 and computer animation.
 KIDO is distinguished by it's accuracy and stability due to its use of
 generalized coordinates to represent articulated rigid body systems and
 computation of Lagrange's equations derived from D.Alembert's principle to
 describe the dynamics of motion.
 For developers, in contrast to many popular physics engines which view the
 simulator as a black box, KIDO gives full access to internal kinematic and
 dynamic quantities, such as the mass matrix, Coriolis and centrifugal forces,
 transformation matrices and their derivatives. KIDO also provides efficient
 computation of Jacobian matrices for arbitrary body points and coordinate
 frames. Contact and collision are handled using an implicit time-stepping,
 velocity-based LCP (linear-complementarity problem) to guarantee
 non-penetration, directional friction, and approximated Coulomb friction cone
 conditions. For collision detection, KIDO uses FCL developed by Willow Garage
 and the UNC Gamma Lab.
 KIDO has applications in robotics and computer animation because it features a
 multibody dynamic simulator and tools for control and motion planning.
 Multibody dynamic simulation in KIDO is an extension of RTQL8, an open source
 software created by the Georgia Tech Graphics Lab.
 This package contains the planning headers and other tools for development.

Package: libkido-planning0.1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Kinematics Dynamics and Optimization Library - planning library
 KIDO is a collaborative, cross-platform, open source library created by the
 Georgia Tech Graphics Lab and Humanoid Robotics Lab. The library provides data
 structures and algorithms for kinematic and dynamic applications in robotics
 and computer animation.
 KIDO is distinguished by it's accuracy and stability due to its use of
 generalized coordinates to represent articulated rigid body systems and
 computation of Lagrange's equations derived from D.Alembert's principle to
 describe the dynamics of motion.
 For developers, in contrast to many popular physics engines which view the
 simulator as a black box, KIDO gives full access to internal kinematic and
 dynamic quantities, such as the mass matrix, Coriolis and centrifugal forces,
 transformation matrices and their derivatives. KIDO also provides efficient
 computation of Jacobian matrices for arbitrary body points and coordinate
 frames. Contact and collision are handled using an implicit time-stepping,
 velocity-based LCP (linear-complementarity problem) to guarantee
 non-penetration, directional friction, and approximated Coulomb friction cone
 conditions. For collision detection, KIDO uses FCL developed by Willow Garage
 and the UNC Gamma Lab.
 KIDO has applications in robotics and computer animation because it features a
 multibody dynamic simulator and tools for control and motion planning.
 Multibody dynamic simulation in KIDO is an extension of RTQL8, an open source
 software created by the Georgia Tech Graphics Lab.
 This package contains the KIDO planning library.

Package: libkido-utils-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         libkido-dev,
         libkido-utils0.1 (= ${binary:Version}),
         libtinyxml-dev,
         libtinyxml2-dev,
         liburdfdom-dev
Description: Kinematics Dynamics and Optimization Library - utils dev files
 KIDO is a collaborative, cross-platform, open source library created by the
 Georgia Tech Graphics Lab and Humanoid Robotics Lab. The library provides data
 structures and algorithms for kinematic and dynamic applications in robotics
 and computer animation.
 KIDO is distinguished by it's accuracy and stability due to its use of
 generalized coordinates to represent articulated rigid body systems and
 computation of Lagrange's equations derived from D.Alembert's principle to
 describe the dynamics of motion.
 For developers, in contrast to many popular physics engines which view the
 simulator as a black box, KIDO gives full access to internal kinematic and
 dynamic quantities, such as the mass matrix, Coriolis and centrifugal forces,
 transformation matrices and their derivatives. KIDO also provides efficient
 computation of Jacobian matrices for arbitrary body points and coordinate
 frames. Contact and collision are handled using an implicit time-stepping,
 velocity-based LCP (linear-complementarity problem) to guarantee
 non-penetration, directional friction, and approximated Coulomb friction cone
 conditions. For collision detection, KIDO uses FCL developed by Willow Garage
 and the UNC Gamma Lab.
 KIDO has applications in robotics and computer animation because it features a
 multibody dynamic simulator and tools for control and motion planning.
 Multibody dynamic simulation in KIDO is an extension of RTQL8, an open source
 software created by the Georgia Tech Graphics Lab.
 This package contains headers and other useful tools for development.

Package: libkido-utils0.1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Kinematics Dynamics and Optimization Library - utils library
 KIDO is a collaborative, cross-platform, open source library created by the
 Georgia Tech Graphics Lab and Humanoid Robotics Lab. The library provides data
 structures and algorithms for kinematic and dynamic applications in robotics
 and computer animation.
 KIDO is distinguished by it's accuracy and stability due to its use of
 generalized coordinates to represent articulated rigid body systems and
 computation of Lagrange's equations derived from D.Alembert's principle to
 describe the dynamics of motion.
 For developers, in contrast to many popular physics engines which view the
 simulator as a black box, KIDO gives full access to internal kinematic and
 dynamic quantities, such as the mass matrix, Coriolis and centrifugal forces,
 transformation matrices and their derivatives. KIDO also provides efficient
 computation of Jacobian matrices for arbitrary body points and coordinate
 frames. Contact and collision are handled using an implicit time-stepping,
 velocity-based LCP (linear-complementarity problem) to guarantee
 non-penetration, directional friction, and approximated Coulomb friction cone
 conditions. For collision detection, KIDO uses FCL developed by Willow Garage
 and the UNC Gamma Lab.
 KIDO has applications in robotics and computer animation because it features a
 multibody dynamic simulator and tools for control and motion planning.
 Multibody dynamic simulation in KIDO is an extension of RTQL8, an open source

=== debian/tests/control ===
Tests: build
Depends: libkido-dev, pkg-config, build-essential
